/* Prototypes for the req.library for use with Lattice. NO! WITH AZTEC 5.0 !!*/

/* WARNING: Not all of the req.library functions are defined here (e.g.
   SimpleRequest and TwoGadRequest are not, because they are in fact only
   assembly language stubs that call TextRequest), so if the linker gives
   you a "(17)Undefined Symbol: " error, you should link with reqglue.o */

void SimpleRequest (char *,...);
int  TwoGadRequest (char *,...);
int  FileRequester (struct FileRequester *);
void Center (struct NewWindow *,int,int);
short SetSize(long,long);
short SetLocation(long,long,long);
long ReadLocation(long,long,short);
void Format(char*,char*,char**);
void DrawBox(struct RastPort*,long,long,long,long);
void PurgeFiles (struct FileRequester *);
int  ColorRequester (long);
int  TextRequest (struct TRStructure *);
char RawKeyToAscii (long,long,APTR);
void MakeButton (struct TwoImageGadget *,char *,char *,long,long,long,long);
void MakeScrollBar (struct ScrollBlock *,long,long,long,long);
void MakeString (char *,char *,char *,ULONG,ULONG,long,long);
void MakeProp  (char *,ULONG,ULONG,ULONG);
void MakeGadget (char *,char *,ULONG,ULONG);
void LinkGadget (struct GadgetBlock *,char *,struct NewWindow *,long,long);
BOOL GetString (char *,char *, struct Window *, long, long);
BOOL GetLong (struct GetLongStruct *);
BOOL NewGetString (struct GetStringStruct *);
void RealTimeScroll (struct ScrollBlock *);
int ExtendedColorRequester (struct ExtendedColorRequester *);

#ifndef __NO_PRAGMAS
#pragma amicall(ReqBase, 0x1e, Center(a0,d0,d1))
#pragma amicall(ReqBase, 0x24, SetSize(d0,d1))
#pragma amicall(ReqBase, 0x2a, SetLocation(d0,d1,d2))
#pragma amicall(ReqBase, 0x30, ReadLocation(d0,d1,d2))
#pragma amicall(ReqBase, 0x36, Format(a0,a1))
#pragma amicall(ReqBase, 0x54, FileRequester(a0))
#pragma amicall(ReqBase, 0x5a, ColorRequester(d0))

#pragma amicall(ReqBase, 0x60, DrawBox(a1,d0,d1,d2,d3))
#pragma amicall(ReqBase, 0x66, MakeButton(a0,a1,a2,d0,d1,d2))

#pragma amicall(ReqBase, 0x6c, MakeScrollBar(a0,d0,d1,d2,d3))
#pragma amicall(ReqBase, 0x72, PurgeFiles(a0))

#pragma amicall(ReqBase, 0x7e, MakeGadget(a0,a1,d0,d1))
#pragma amicall(ReqBase, 0x84, MakeString(a0,a1,a2,d0,d1,d2,d3))
#pragma amicall(ReqBase, 0x8a, MakeProp(a0,d0,d1,d2))

#pragma amicall(ReqBase, 0x90, LinkGadget(a0,a1,a3,d0,d1))
#pragma amicall(ReqBase, 0xa2, GetString(a0,a1,a2,d0,d1))
#pragma amicall(ReqBase, 0xa8, RealTimeScroll(a0))

#pragma amicall(ReqBase, 0xae, TextRequest(a0))
#pragma amicall(ReqBase, 0xb4, GetLong(a0))
#pragma amicall(ReqBase, 0xba, RawKeyToAscii(d0,d1,a0))
#pragma amicall(ReqBase, 0xc0, ExtendedColorRequester(a0))
#pragma amicall(ReqBase, 0xc6, NewGetString(a0))

/***********************************************************************/
/* LinkString and LinkProp have been omitted, as they require too many */
/* parameters for pragging. However, new versions of these functions   */
/* are planned, to take care of this. Stay tuned.                      */
/*                                                        C.W. Fox     */
/***********************************************************************/


/**************************************************************************/
/* Also, GetFontHeightAndWidth has been left out, as it returns values in */
/* two registers, which is difficult to manage from C.                    */
/*                                                        C.W. Fox        */
/**************************************************************************/

#endif
